package betterquesting.api.questing.tasks;

import betterquesting.api.questing.IQuest;
import betterquesting.api2.client.gui.misc.IGuiRect;
import betterquesting.api2.client.gui.panels.IGuiPanel;
import betterquesting.api2.storage.DBEntry;
import betterquesting.api2.storage.INBTProgress;
import betterquesting.api2.storage.INBTSaveLoad;
import betterquesting.api2.utils.ParticipantInfo;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import java.util.UUID;
import javax.annotation.Nullable;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ResourceLocation;

/* loaded from: betterquesting_api_questing_tasks.jar:betterquesting/api/questing/tasks/ITask.class */
public interface ITask extends INBTSaveLoad<NBTTagCompound>, INBTProgress<NBTTagCompound> {
    String getUnlocalisedName();

    ResourceLocation getFactoryID();

    void detect(ParticipantInfo participantInfo, DBEntry<IQuest> dBEntry);

    boolean isComplete(UUID uuid);

    void setComplete(UUID uuid);

    void resetUser(@Nullable UUID uuid);

    @SideOnly(Side.CLIENT)
    @Nullable
    IGuiPanel getTaskGui(IGuiRect iGuiRect, DBEntry<IQuest> dBEntry);

    @SideOnly(Side.CLIENT)
    @Nullable
    GuiScreen getTaskEditor(GuiScreen guiScreen, DBEntry<IQuest> dBEntry);
}
